Index: build/premake/extern_libs4.lua
===================================================================
--- build/premake/extern_libs4.lua	(Revision 14578)
+++ build/premake/extern_libs4.lua	(Arbeitskopie)
@@ -562,38 +562,41 @@
 	},
 	spidermonkey = {
 		compile_settings = function()
-			if _OPTIONS["with-system-mozjs185"] then
-				if not _OPTIONS["android"] then
-					pkgconfig_cflags("mozjs185")
-				end
-				defines { "WITH_SYSTEM_MOZJS185" }
+			if _OPTIONS["with-system-mozjs24"] then
+				-- to be implemented when such system packages exist
+				--if not _OPTIONS["android"] then
+				--	pkgconfig_cflags("mozjs24")
+				--end
+				--defines { "WITH_SYSTEM_MOZJS24" }
 			else
 				if os.is("windows") then
 					include_dir = "include-win32"
 				elseif os.is("macosx") then
-					include_dir = "include"
+					include_dir = "include-unix"
 				else
 					include_dir = "include-unix"
 				end
 				configuration "Debug"
-					includedirs { libraries_source_dir.."spidermonkey/"..include_dir }
+					includedirs { libraries_source_dir.."spidermonkey/"..include_dir.."-debug" }
+					defines { "DEBUG" }
 				configuration "Release"
-					includedirs { libraries_source_dir.."spidermonkey/"..include_dir }
+					includedirs { libraries_source_dir.."spidermonkey/"..include_dir.."-release" }
 				configuration { }
 			end
 		end,
 		link_settings = function()
-			if _OPTIONS["with-system-mozjs185"] then
-				if _OPTIONS["android"] then
-					links { "mozjs185-1.0" }
-				else
-					pkgconfig_libs("mozjs185")
-				end
+			if _OPTIONS["with-system-mozjs24"] then
+				-- to be implemented when such system packages exist
+				--if _OPTIONS["android"] then
+				--	links { "mozjs185-1.0" }
+				--else
+				--	pkgconfig_libs("mozjs185")
+				--end
 			else
 				configuration "Debug"
-					links { "mozjs185-ps-debug" }
+					links { "mozjs24-ps-debug" }
 				configuration "Release"
-					links { "mozjs185-ps-release" }
+					links { "mozjs24-ps-release" }
 				configuration { }
 				add_source_lib_paths("spidermonkey")
 			end
Index: build/premake/premake4.lua
===================================================================
--- build/premake/premake4.lua	(Revision 14578)
+++ build/premake/premake4.lua	(Arbeitskopie)
@@ -15,7 +15,7 @@
 newoption { trigger = "with-system-nvtt", description = "Search standard paths for nvidia-texture-tools library, instead of using bundled copy" }
 newoption { trigger = "with-system-enet", description = "Search standard paths for libenet, instead of using bundled copy" }
 newoption { trigger = "with-system-miniupnpc", description = "Search standard paths for libminiupnpc, instead of using bundled copy" }
-newoption { trigger = "with-system-mozjs185", description = "Search standard paths for libmozjs185, instead of using bundled copy" }
+newoption { trigger = "with-system-mozjs24", description = "Search standard paths for libmozjs24, instead of using bundled copy" }
 newoption { trigger = "with-c++11", description = "Enable C++11 on GCC" }
 newoption { trigger = "sysroot", description = "Set compiler system root path, used for building against a non-system SDK. For example /usr/local becomes SYSROOT/user/local" }
 newoption { trigger = "macosx-version-min", description = "Set minimum required version of the OS X API, the build will possibly fail if an older SDK is used, while newer API functions will be weakly linked (i.e. resolved at runtime)" }
Index: source/simulation2/serialization/BinarySerializer.h
===================================================================
--- source/simulation2/serialization/BinarySerializer.h	(Revision 14578)
+++ source/simulation2/serialization/BinarySerializer.h	(Arbeitskopie)
@@ -20,8 +20,6 @@
 
 #include "ISerializer.h"
 
-#include "scriptinterface/AutoRooters.h"
-
 #include "lib/byte_order.h"
 #include "lib/allocators/arena.h"
 
@@ -73,7 +71,7 @@
 	u32 m_ScriptBackrefsNext;
 	u32 GetScriptBackrefTag(JSObject* obj);
 
-	AutoGCRooter m_Rooter;
+	JS::AutoObjectVector m_Rooter;
 
 	std::map<JSObject*, std::wstring> m_SerializablePrototypes;
 
Index: source/simulation2/serialization/StdDeserializer.cpp
===================================================================
--- source/simulation2/serialization/StdDeserializer.cpp	(Revision 14578)
+++ source/simulation2/serialization/StdDeserializer.cpp	(Arbeitskopie)
@@ -25,37 +25,8 @@
 #include "scriptinterface/ScriptInterface.h"
 #include "scriptinterface/ScriptExtraHeaders.h" // for typed arrays
 
-#include "js/jsapi.h"
-
 #include "lib/byte_order.h"
 
-static uint32 GetJSArrayType(u8 arrayType)
-{
-	switch(arrayType)
-	{
-	case SCRIPT_TYPED_ARRAY_INT8:
-		return js::TypedArray::TYPE_INT8;
-	case SCRIPT_TYPED_ARRAY_UINT8:
-		return js::TypedArray::TYPE_UINT8;
-	case SCRIPT_TYPED_ARRAY_INT16:
-		return js::TypedArray::TYPE_INT16;
-	case SCRIPT_TYPED_ARRAY_UINT16:
-		return js::TypedArray::TYPE_UINT16;
-	case SCRIPT_TYPED_ARRAY_INT32:
-		return js::TypedArray::TYPE_INT32;
-	case SCRIPT_TYPED_ARRAY_UINT32:
-		return js::TypedArray::TYPE_UINT32;
-	case SCRIPT_TYPED_ARRAY_FLOAT32:
-		return js::TypedArray::TYPE_FLOAT32;
-	case SCRIPT_TYPED_ARRAY_FLOAT64:
-		return js::TypedArray::TYPE_FLOAT64;
-	case SCRIPT_TYPED_ARRAY_UINT8_CLAMPED:
-		return js::TypedArray::TYPE_UINT8_CLAMPED;
-	default:
-		throw PSERROR_Deserialize_ScriptError("Failed to deserialize unrecognized typed array view");
-	}
-}
-
 CStdDeserializer::CStdDeserializer(ScriptInterface& scriptInterface, std::istream& stream) :
 	m_ScriptInterface(scriptInterface), m_Stream(stream)
 {
@@ -138,11 +109,13 @@
 
 void CStdDeserializer::FreeScriptBackrefs()
 {
+	JSContext* cx = m_ScriptInterface.GetContext();
+	JSAutoRequest rq(cx);
+	
 	std::map<u32, JSObject*>::iterator it = m_ScriptBackrefs.begin();
 	for (; it != m_ScriptBackrefs.end(); ++it)
 	{
-		if (!JS_RemoveObjectRoot(m_ScriptInterface.GetContext(), &it->second))
-			throw PSERROR_Deserialize_ScriptError("JS_RemoveRoot failed");
+		JS_RemoveObjectRoot(m_ScriptInterface.GetContext(), &it->second);
 	}
 	m_ScriptBackrefs.clear();
 }
@@ -152,6 +125,8 @@
 jsval CStdDeserializer::ReadScriptVal(const char* UNUSED(name), JSObject* appendParent)
 {
 	JSContext* cx = m_ScriptInterface.GetContext();
+	
+	JSAutoRequest rq(cx);
 
 	uint8_t type;
 	NumberU8_Unbounded("type", type);
@@ -192,7 +167,7 @@
 			if (!proto)
 				throw PSERROR_Deserialize_ScriptError("Failed to find serializable prototype for object");
 
-			JSObject* parent = JS_GetParent(cx, proto);
+			JSObject* parent = JS_GetParent(proto);
 			if (!proto || !parent)
 				throw PSERROR_Deserialize_ScriptError();
 
@@ -206,11 +181,11 @@
 			JSBool hasCustomDeserialize, hasCustomSerialize;
 			if (!JS_HasProperty(cx, obj, "Serialize", &hasCustomSerialize) || !JS_HasProperty(cx, obj, "Deserialize", &hasCustomDeserialize))
 				throw PSERROR_Serialize_ScriptError("JS_HasProperty failed");
-			
+
 			if (hasCustomDeserialize)
 			{
-				jsval serialize;
-				if (!JS_LookupProperty(cx, obj, "Serialize", &serialize))
+				JS::RootedValue serialize(cx);
+				if (!JS_LookupProperty(cx, obj, "Serialize", serialize.address()))
 					throw PSERROR_Serialize_ScriptError("JS_LookupProperty failed");
 				bool hasNullSerialize = hasCustomSerialize && JSVAL_IS_NULL(serialize);
 
@@ -241,10 +216,10 @@
 			utf16string propname;
 			ReadStringUTF16("prop name", propname);
 
-			jsval propval = ReadScriptVal("prop value", NULL);
+			JS::RootedValue propval(cx, ReadScriptVal("prop value", NULL));
 			CScriptValRooted propvalRoot(cx, propval);
 
-			if (!JS_SetUCProperty(cx, obj, (const jschar*)propname.data(), propname.length(), &propval))
+			if (!JS_SetUCProperty(cx, obj, (const jschar*)propname.data(), propname.length(), propval.address()))
 				throw PSERROR_Deserialize_ScriptError();
 		}
 
@@ -266,8 +241,8 @@
 	{
 		double value;
 		NumberDouble_Unbounded("value", value);
-		jsval rval;
-		if (!JS_NewNumberValue(cx, value, &rval))
+		jsval rval = JS_NumberValue(value);
+		if (JSVAL_IS_NULL(rval))
 			throw PSERROR_Deserialize_ScriptError("JS_NewNumberValue failed");
 		return rval;
 	}
@@ -275,7 +250,7 @@
 	{
 		uint8_t value;
 		NumberU8("value", value, 0, 1);
-		return BOOLEAN_TO_JSVAL(value ? JS_TRUE : JS_FALSE);
+		return BOOLEAN_TO_JSVAL(value ? true : false);
 	}
 	case SCRIPT_TYPE_BACKREF:
 	{
@@ -290,16 +265,14 @@
 	{
 		double value;
 		NumberDouble_Unbounded("value", value);
-		jsval val;
-		if (!JS_NewNumberValue(cx, value, &val))
-			throw PSERROR_Deserialize_ScriptError();
+		JS::RootedValue val(cx, JS_NumberValue(value));
 		CScriptValRooted objRoot(cx, val);
 
 		JSObject* ctorobj;
-		if (!JS_GetClassObject(cx, JS_GetGlobalObject(cx), JSProto_Number, &ctorobj))
+		if (!JS_GetClassObject(cx, JS_GetGlobalForScopeChain(cx), JSProto_Number, &ctorobj))
 			throw PSERROR_Deserialize_ScriptError("JS_GetClassObject failed");
 
-		JSObject* obj = JS_New(cx, ctorobj, 1, &val);
+		JSObject* obj = JS_New(cx, ctorobj, 1, val.address());
 		if (!obj)
 			throw PSERROR_Deserialize_ScriptError("JS_New failed");
 		AddScriptBackref(obj);
@@ -311,14 +284,14 @@
 		ScriptString("value", str);
 		if (!str)
 			throw PSERROR_Deserialize_ScriptError();
-		jsval val = STRING_TO_JSVAL(str);
+		JS::RootedValue val(cx, STRING_TO_JSVAL(str));
 		CScriptValRooted valRoot(cx, val);
 
 		JSObject* ctorobj;
-		if (!JS_GetClassObject(cx, JS_GetGlobalObject(cx), JSProto_String, &ctorobj))
+		if (!JS_GetClassObject(cx, JS_GetGlobalForScopeChain(cx), JSProto_String, &ctorobj))
 			throw PSERROR_Deserialize_ScriptError("JS_GetClassObject failed");
 
-		JSObject* obj = JS_New(cx, ctorobj, 1, &val);
+		JSObject* obj = JS_New(cx, ctorobj, 1, val.address());
 		if (!obj)
 			throw PSERROR_Deserialize_ScriptError("JS_New failed");
 		AddScriptBackref(obj);
@@ -328,14 +301,13 @@
 	{
 		bool value;
 		Bool("value", value);
-		jsval val = BOOLEAN_TO_JSVAL(value ? JS_TRUE : JS_FALSE);
-		CScriptValRooted objRoot(cx, val);
+		JS::RootedValue val(cx, BOOLEAN_TO_JSVAL(value));
 
 		JSObject* ctorobj;
-		if (!JS_GetClassObject(cx, JS_GetGlobalObject(cx), JSProto_Boolean, &ctorobj))
+		if (!JS_GetClassObject(cx, JS_GetGlobalForScopeChain(cx), JSProto_Boolean, &ctorobj))
 			throw PSERROR_Deserialize_ScriptError("JS_GetClassObject failed");
 
-		JSObject* obj = JS_New(cx, ctorobj, 1, &val);
+		JSObject* obj = JS_New(cx, ctorobj, 1, val.address());
 		if (!obj)
 			throw PSERROR_Deserialize_ScriptError("JS_New failed");
 		AddScriptBackref(obj);
@@ -354,16 +326,47 @@
 
 		// Get buffer object
 		jsval bufferVal = ReadScriptVal("buffer", NULL);
-		CScriptValRooted bufferValRoot(cx, bufferVal);
 
-		if (!JSVAL_IS_OBJECT(bufferVal))
+		if (JSVAL_IS_PRIMITIVE(bufferVal))
 			throw PSERROR_Deserialize_ScriptError();
 
 		JSObject* bufferObj = JSVAL_TO_OBJECT(bufferVal);
-		if (!js_IsArrayBuffer(bufferObj))
+		if (!JS_IsArrayBufferObject(bufferObj))
 			throw PSERROR_Deserialize_ScriptError("js_IsArrayBuffer failed");
 
-		JSObject* arrayObj = js_CreateTypedArrayWithBuffer(cx, GetJSArrayType(arrayType), bufferObj, byteOffset, length);
+		JSObject* arrayObj;
+		switch(arrayType)
+		{
+		case SCRIPT_TYPED_ARRAY_INT8:
+			arrayObj = JS_NewInt8ArrayWithBuffer(cx, bufferObj, byteOffset, length);
+			break;
+		case SCRIPT_TYPED_ARRAY_UINT8:
+			arrayObj = JS_NewUint8ArrayWithBuffer(cx, bufferObj, byteOffset, length);
+			break;
+		case SCRIPT_TYPED_ARRAY_INT16:
+			arrayObj = JS_NewInt16ArrayWithBuffer(cx, bufferObj, byteOffset, length);
+			break;
+		case SCRIPT_TYPED_ARRAY_UINT16:
+			arrayObj = JS_NewUint16ArrayWithBuffer(cx, bufferObj, byteOffset, length);
+			break;
+		case SCRIPT_TYPED_ARRAY_INT32:
+			arrayObj = JS_NewInt32ArrayWithBuffer(cx, bufferObj, byteOffset, length);
+			break;
+		case SCRIPT_TYPED_ARRAY_UINT32:
+			arrayObj = JS_NewUint32ArrayWithBuffer(cx, bufferObj, byteOffset, length);
+			break;
+		case SCRIPT_TYPED_ARRAY_FLOAT32:
+			arrayObj = JS_NewFloat32ArrayWithBuffer(cx, bufferObj, byteOffset, length);
+			break;
+		case SCRIPT_TYPED_ARRAY_FLOAT64:
+			arrayObj = JS_NewFloat64ArrayWithBuffer(cx, bufferObj, byteOffset, length);
+			break;
+		case SCRIPT_TYPED_ARRAY_UINT8_CLAMPED:
+			arrayObj = JS_NewUint8ClampedArrayWithBuffer(cx, bufferObj, byteOffset, length);
+			break;
+		default:
+			throw PSERROR_Deserialize_ScriptError("Failed to deserialize unrecognized typed array view");
+		}
 		if (!arrayObj)
 			throw PSERROR_Deserialize_ScriptError("js_CreateTypedArrayWithBuffer failed");
 
@@ -383,16 +386,9 @@
 #error TODO: need to convert JS ArrayBuffer data from little-endian
 #endif
 
-		JSObject* bufferObj = js_CreateArrayBuffer(cx, length);
-		if (!bufferObj)
-			throw PSERROR_Deserialize_ScriptError("js_CreateArrayBuffer failed");
-
+		JSObject* bufferObj = JS_NewArrayBufferWithContents(cx, (void*)bufferData);
 		AddScriptBackref(bufferObj);
 
-		js::ArrayBuffer* buffer = js::ArrayBuffer::fromJSObject(bufferObj);
-		memcpy(buffer->data, bufferData, length);
-		delete[] bufferData;
-
 		return OBJECT_TO_JSVAL(bufferObj);
 	}
 	default:
@@ -440,7 +436,7 @@
 
 void CStdDeserializer::ScriptObjectAppend(const char* name, jsval& obj)
 {
-	if (!JSVAL_IS_OBJECT(obj))
+	if (JSVAL_IS_PRIMITIVE(obj))
 		throw PSERROR_Deserialize_ScriptError();
 
 	ReadScriptVal(name, JSVAL_TO_OBJECT(obj));
Index: source/simulation2/serialization/BinarySerializer.cpp
===================================================================
--- source/simulation2/serialization/BinarySerializer.cpp	(Revision 14578)
+++ source/simulation2/serialization/BinarySerializer.cpp	(Arbeitskopie)
@@ -19,35 +19,34 @@
 
 #include "BinarySerializer.h"
 
-#include "SerializedScriptTypes.h"
-
 #include "lib/alignment.h"
 #include "ps/CLogger.h"
 
 #include "scriptinterface/ScriptInterface.h"
 #include "scriptinterface/ScriptExtraHeaders.h" // for JSDOUBLE_IS_INT32, typed arrays
+#include "SerializedScriptTypes.h"
 
-static u8 GetArrayType(uint32 arrayType)
+static u8 GetArrayType(JSArrayBufferViewType arrayType)
 {
 	switch(arrayType)
 	{
-	case js::TypedArray::TYPE_INT8:
+	case JSArrayBufferViewType::TYPE_INT8:
 		return SCRIPT_TYPED_ARRAY_INT8;
-	case js::TypedArray::TYPE_UINT8:
+	case JSArrayBufferViewType::TYPE_UINT8:
 		return SCRIPT_TYPED_ARRAY_UINT8;
-	case js::TypedArray::TYPE_INT16:
+	case JSArrayBufferViewType::TYPE_INT16:
 		return SCRIPT_TYPED_ARRAY_INT16;
-	case js::TypedArray::TYPE_UINT16:
+	case JSArrayBufferViewType::TYPE_UINT16:
 		return SCRIPT_TYPED_ARRAY_UINT16;
-	case js::TypedArray::TYPE_INT32:
+	case JSArrayBufferViewType::TYPE_INT32:
 		return SCRIPT_TYPED_ARRAY_INT32;
-	case js::TypedArray::TYPE_UINT32:
+	case JSArrayBufferViewType::TYPE_UINT32:
 		return SCRIPT_TYPED_ARRAY_UINT32;
-	case js::TypedArray::TYPE_FLOAT32:
+	case JSArrayBufferViewType::TYPE_FLOAT32:
 		return SCRIPT_TYPED_ARRAY_FLOAT32;
-	case js::TypedArray::TYPE_FLOAT64:
+	case JSArrayBufferViewType::TYPE_FLOAT64:
 		return SCRIPT_TYPED_ARRAY_FLOAT64;
-	case js::TypedArray::TYPE_UINT8_CLAMPED:
+	case JSArrayBufferViewType::TYPE_UINT8_CLAMPED:
 		return SCRIPT_TYPED_ARRAY_UINT8_CLAMPED;
 	default:
 		LOGERROR(L"Cannot serialize unrecognized typed array view: %d", arrayType);
@@ -56,14 +55,15 @@
 }
 
 CBinarySerializerScriptImpl::CBinarySerializerScriptImpl(ScriptInterface& scriptInterface, ISerializer& serializer) :
-	m_ScriptInterface(scriptInterface), m_Serializer(serializer), m_Rooter(m_ScriptInterface),
+	m_ScriptInterface(scriptInterface), m_Serializer(serializer), m_Rooter(m_ScriptInterface.GetContext()),
 	m_ScriptBackrefsArena(1 * MiB), m_ScriptBackrefs(backrefs_t::key_compare(), ScriptBackrefsAlloc(m_ScriptBackrefsArena)), m_ScriptBackrefsNext(1)
 {
 }
-
+// TODO YGW: Test serialization...
 void CBinarySerializerScriptImpl::HandleScriptVal(jsval val)
 {
 	JSContext* cx = m_ScriptInterface.GetContext();
+	JSAutoRequest rq(cx);
 
 	switch (JS_TypeOfValue(cx, val))
 	{
@@ -85,7 +85,8 @@
 			break;
 		}
 
-		JSObject* obj = JSVAL_TO_OBJECT(val);
+		//JSObject* obj = JSVAL_TO_OBJECT(val);
+		JS::RootedObject obj(cx, JSVAL_TO_OBJECT(val));
 
 		// If we've already serialized this object, just output a reference to it
 		u32 tag = GetScriptBackrefTag(obj);
@@ -104,53 +105,52 @@
 
 			// Arrays like [1, 2, ] have an 'undefined' at the end which is part of the
 			// length but seemingly isn't enumerated, so store the length explicitly
-			jsuint length = 0;
+			uint length = 0;
 			if (!JS_GetArrayLength(cx, obj, &length))
 				throw PSERROR_Serialize_ScriptError("JS_GetArrayLength failed");
 			m_Serializer.NumberU32_Unbounded("array length", length);
 		}
-		else if (js_IsTypedArray(obj))
+		//JS_IsArrayBufferViewObject()
+		//JS_IsTypedArrayObject()
+		else if (JS_IsTypedArrayObject(obj))
 		{
 			m_Serializer.NumberU8_Unbounded("type", SCRIPT_TYPE_TYPED_ARRAY);
 
-			js::TypedArray* typedArray = js::TypedArray::fromJSObject(obj);
-			
-			m_Serializer.NumberU8_Unbounded("array type", GetArrayType(typedArray->type));
-			m_Serializer.NumberU32_Unbounded("byte offset", typedArray->byteOffset);
-			m_Serializer.NumberU32_Unbounded("length", typedArray->length);
+			m_Serializer.NumberU8_Unbounded("array type", GetArrayType(JS_GetArrayBufferViewType(obj)));
+			m_Serializer.NumberU32_Unbounded("byte offset", JS_GetTypedArrayByteOffset(obj));
+			m_Serializer.NumberU32_Unbounded("length", JS_GetTypedArrayLength(obj));
 
 			// Now handle its array buffer
 			// this may be a backref, since ArrayBuffers can be shared by multiple views
-			HandleScriptVal(OBJECT_TO_JSVAL(typedArray->bufferJS));
+			HandleScriptVal(OBJECT_TO_JSVAL(JS_GetArrayBufferViewBuffer(obj)));
 			break;
 		}
-		else if (js_IsArrayBuffer(obj))
+		else if (JS_IsArrayBufferObject(obj))
 		{
 			m_Serializer.NumberU8_Unbounded("type", SCRIPT_TYPE_ARRAY_BUFFER);
 
-			js::ArrayBuffer* arrayBuffer = js::ArrayBuffer::fromJSObject(obj);
-
 #if BYTE_ORDER != LITTLE_ENDIAN
 #error TODO: need to convert JS ArrayBuffer data to little-endian
 #endif
 
-			u32 length = arrayBuffer->byteLength;
+			u32 length = JS_GetArrayBufferByteLength(obj);
 			m_Serializer.NumberU32_Unbounded("buffer length", length);
-			m_Serializer.RawBytes("buffer data", (const u8*)arrayBuffer->data, length);
+			m_Serializer.RawBytes("buffer data", (const u8*)JS_GetArrayBufferData(obj), length);
 			break;
 		}
 		else
 		{
 			// Find type of object
-			JSClass* jsclass = JS_GET_CLASS(cx, obj);
+			JSClass* jsclass = JS_GetClass(obj);
 			if (!jsclass)
-				throw PSERROR_Serialize_ScriptError("JS_GET_CLASS failed");
+				throw PSERROR_Serialize_ScriptError("JS_GetClass failed");
 			JSProtoKey protokey = JSCLASS_CACHED_PROTO_KEY(jsclass);
 
 			if (protokey == JSProto_Object)
 			{
 				// Object class - check for user-defined prototype
-				JSObject* proto = JS_GetPrototype(cx, obj);
+				JS::RootedObject proto(cx);
+				JS_GetPrototype(cx, obj, proto.address());
 				if (!proto)
 					throw PSERROR_Serialize_ScriptError("JS_GetPrototype failed");
 
@@ -175,11 +175,11 @@
 					JSBool hasCustomSerialize;
 					if (!JS_HasProperty(cx, obj, "Serialize", &hasCustomSerialize))
 						throw PSERROR_Serialize_ScriptError("JS_HasProperty failed");
-					
+
 					if (hasCustomSerialize)
 					{
-						jsval serialize;
-						if (!JS_LookupProperty(cx, obj, "Serialize", &serialize))
+						JS::RootedValue serialize(cx);
+						if (!JS_LookupProperty(cx, obj, "Serialize", serialize.address()))
 							throw PSERROR_Serialize_ScriptError("JS_LookupProperty failed");
 
 						// If serialize is null, so don't serialize anything more
@@ -199,7 +199,7 @@
 				// Standard Number object
 				m_Serializer.NumberU8_Unbounded("type", SCRIPT_TYPE_OBJECT_NUMBER);
 				// Get primitive value
-				jsdouble d;
+				double d;
 				if (!JS_ValueToNumber(cx, val, &d))
 					throw PSERROR_Serialize_ScriptError("JS_ValueToNumber failed");
 				m_Serializer.NumberDouble_Unbounded("value", d);
@@ -224,7 +224,7 @@
 				JSBool b;
 				if (!JS_ValueToBoolean(cx, val, &b))
 					throw PSERROR_Serialize_ScriptError("JS_ValueToBoolean failed");
-				m_Serializer.Bool("value", b == JS_TRUE);
+				m_Serializer.Bool("value", b);
 				break;
 			}
 			else
@@ -240,8 +240,8 @@
 		// (Note that we don't do any rooting, because we assume nothing is going to trigger GC.
 		// I'm not absolute certain that's necessarily a valid assumption.)
 
-		AutoJSIdArray ida (cx, JS_Enumerate(cx, obj));
-		if (!ida.get())
+		JS::AutoIdArray ida (cx, JS_Enumerate(cx, obj));
+		if (!ida)
 			throw PSERROR_Serialize_ScriptError("JS_Enumerate failed");
 
 		m_Serializer.NumberU32_Unbounded("num props", (uint32_t)ida.length());
@@ -250,12 +250,13 @@
 		{
 			jsid id = ida[i];
 
-			jsval idval, propval;
-
+			JS::RootedValue idval(cx);
+			JS::RootedValue propval(cx);
+			
 			// Get the property name as a string
-			if (!JS_IdToValue(cx, id, &idval))
+			if (!JS_IdToValue(cx, id, idval.address()))
 				throw PSERROR_Serialize_ScriptError("JS_IdToValue failed");
-			JSString* idstr = JS_ValueToString(cx, idval);
+			JSString* idstr = JS_ValueToString(cx, idval.get());
 			if (!idstr)
 				throw PSERROR_Serialize_ScriptError("JS_ValueToString failed");
 
@@ -263,7 +264,7 @@
 
 			// Use LookupProperty instead of GetProperty to avoid the danger of getters
 			// (they might delete values and trigger GC)
-			if (!JS_LookupPropertyById(cx, obj, id, &propval))
+			if (!JS_LookupPropertyById(cx, obj, id, propval.address()))
 				throw PSERROR_Serialize_ScriptError("JS_LookupPropertyById failed");
 
 			HandleScriptVal(propval);
@@ -308,36 +309,18 @@
 		else
 		{
 			ENSURE(JSVAL_IS_DOUBLE(val));
-
-			// If the value fits in an int, serialise as an int
-			jsdouble d = JSVAL_TO_DOUBLE(val);
-			int32_t i;
-			if (JSDOUBLE_IS_INT32(d, &i))
-			{
-				m_Serializer.NumberU8_Unbounded("type", SCRIPT_TYPE_INT);
-				m_Serializer.NumberI32_Unbounded("value", i);
-			}
-			// Otherwise serialise as a double
-			else
-			{
-				m_Serializer.NumberU8_Unbounded("type", SCRIPT_TYPE_DOUBLE);
-				m_Serializer.NumberDouble_Unbounded("value", d);
-			}
+			m_Serializer.NumberU8_Unbounded("type", SCRIPT_TYPE_DOUBLE);
+			m_Serializer.NumberDouble_Unbounded("value", JSVAL_TO_DOUBLE(val));
 		}
 		break;
 	}
 	case JSTYPE_BOOLEAN:
 	{
 		m_Serializer.NumberU8_Unbounded("type", SCRIPT_TYPE_BOOLEAN);
-		JSBool b = JSVAL_TO_BOOLEAN(val);
+		bool b = JSVAL_TO_BOOLEAN(val);
 		m_Serializer.NumberU8_Unbounded("value", b ? 1 : 0);
 		break;
 	}
-	case JSTYPE_XML:
-	{
-		LOGERROR(L"Cannot serialise JS objects of type 'xml'");
-		throw PSERROR_Serialize_InvalidScriptValue();
-	}
 	default:
 	{
 		debug_warn(L"Invalid TypeOfValue");
@@ -349,6 +332,8 @@
 void CBinarySerializerScriptImpl::ScriptString(const char* name, JSString* string)
 {
 	JSContext* cx = m_ScriptInterface.GetContext();
+	JSAutoRequest rq(cx);
+
 	size_t length;
 	const jschar* chars = JS_GetStringCharsAndLength(cx, string, &length);
 
@@ -382,7 +367,12 @@
 
 	// If it was newly inserted, we need to make sure it gets rooted
 	// for the duration that it's in m_ScriptBackrefs
-	m_Rooter.Push(it.first->first);
+	// Note: Spidermonkey has a moving GC. JSObject pointers in this mapping table can change,
+	// but we have registered a custom trace call for the time m_ScriptBackrefs is alive which
+	// takes care of updating the pointers in our mapping table.
+	// TODO: Could this be bad for GC-Performance if we serialize large objects and keep the Serializer
+    // (including m_ScriptBackrefs) alive? Do we keep it alive somewhere?
+    m_Rooter.append(it.first->first);
 	m_ScriptBackrefsNext++;
 	// Return a non-tag number so callers know they need to serialize the object
 	return 0;
Index: source/simulation2/system/ComponentManager.cpp
===================================================================
--- source/simulation2/system/ComponentManager.cpp	(Revision 14578)
+++ source/simulation2/system/ComponentManager.cpp	(Arbeitskopie)
@@ -243,12 +243,12 @@
 
 	// Find all the ctor prototype's On* methods, and subscribe to the appropriate messages:
 
-	CScriptVal proto;
+	JS::RootedObject proto(componentManager->m_ScriptInterface.GetContext());
 	if (!componentManager->m_ScriptInterface.GetProperty(ctor.get(), "prototype", proto))
 		return; // error
 
 	std::vector<std::string> methods;
-	if (!componentManager->m_ScriptInterface.EnumeratePropertyNamesWithPrefix(proto.get(), "On", methods))
+	if (!componentManager->m_ScriptInterface.EnumeratePropertyNamesWithPrefix(proto, "On", methods))
 		return; // error
 
 	for (std::vector<std::string>::const_iterator it = methods.begin(); it != methods.end(); ++it)
@@ -289,7 +289,10 @@
 		{
 			jsval instance = eit->second->GetJSInstance();
 			if (!JSVAL_IS_NULL(instance))
-				componentManager->m_ScriptInterface.SetPrototype(instance, proto.get());
+			{
+				JS::RootedObject instanceObj(componentManager->m_ScriptInterface.GetContext(),&instance.toObject());
+				componentManager->m_ScriptInterface.SetPrototype(instanceObj, proto);
+			}
 		}
 	}
 }
@@ -616,7 +619,7 @@
 	jsval obj = JSVAL_NULL;
 	if (ct.type == CT_Script)
 	{
-		obj = m_ScriptInterface.CallConstructor(ct.ctor.get(), JSVAL_VOID);
+		obj = m_ScriptInterface.CallConstructor(ct.ctor.get(), 0, JSVAL_VOID);
 		if (JSVAL_IS_VOID(obj))
 		{
 			LOGERROR(L"Script component constructor failed");
Index: source/simulation2/system/InterfaceScripted.h
===================================================================
--- source/simulation2/system/InterfaceScripted.h	(Revision 14578)
+++ source/simulation2/system/InterfaceScripted.h	(Arbeitskopie)
@@ -19,14 +19,12 @@
 #define INCLUDED_INTERFACE_SCRIPTED
 
 #include "scriptinterface/ScriptInterface.h"
-#include "js/jsapi.h"
 
 #define BEGIN_INTERFACE_WRAPPER(iname) \
 	JSClass class_ICmp##iname = { \
 		"ICmp" #iname, JSCLASS_HAS_PRIVATE, \
-		JS_PropertyStub, JS_PropertyStub, JS_PropertyStub, JS_StrictPropertyStub, \
-		JS_EnumerateStub, JS_ResolveStub, JS_ConvertStub, JS_FinalizeStub, \
-		JSCLASS_NO_OPTIONAL_MEMBERS \
+		JS_PropertyStub, JS_DeletePropertyStub, JS_PropertyStub, JS_StrictPropertyStub, \
+		JS_EnumerateStub, JS_ResolveStub, JS_ConvertStub \
 	}; \
 	static JSFunctionSpec methods_ICmp##iname[] = {
 
@@ -35,7 +33,8 @@
 	}; \
 	void ICmp##iname::InterfaceInit(ScriptInterface& scriptInterface) { \
 		JSContext* cx = scriptInterface.GetContext(); \
-		JSObject* global = JS_GetGlobalObject(cx); \
+		JSAutoRequest rq(cx); \
+		JSObject* global = JS_GetGlobalForScopeChain(cx); \
 		JS_InitClass(cx, global, NULL, &class_ICmp##iname, NULL, 0, NULL, methods_ICmp##iname, NULL, NULL); \
 	} \
 	JSClass* ICmp##iname::GetJSClass() const { return &class_ICmp##iname; } \
@@ -45,49 +44,49 @@
 
 #define DEFINE_INTERFACE_METHOD_0(scriptname, rettype, classname, methodname) \
 	{ scriptname, \
-		ScriptInterface::callMethod<rettype, &class_##classname, classname, &classname::methodname>, \
+		{ ScriptInterface::callMethod<rettype, &class_##classname, classname, &classname::methodname>, NULL }, \
 		0, \
 		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_1(scriptname, rettype, classname, methodname, arg1) \
 	{ scriptname, \
-		ScriptInterface::callMethod<rettype, arg1, &class_##classname, classname, &classname::methodname>, \
+		{ ScriptInterface::callMethod<rettype, arg1, &class_##classname, classname, &classname::methodname>, NULL}, \
 		1, \
 		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_2(scriptname, rettype, classname, methodname, arg1, arg2) \
 	{ scriptname, \
-		ScriptInterface::callMethod<rettype, arg1, arg2, &class_##classname, classname, &classname::methodname>, \
+		{ ScriptInterface::callMethod<rettype, arg1, arg2, &class_##classname, classname, &classname::methodname>, NULL }, \
 		2, \
 		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_3(scriptname, rettype, classname, methodname, arg1, arg2, arg3) \
 	{ scriptname, \
-		ScriptInterface::callMethod<rettype, arg1, arg2, arg3, &class_##classname, classname, &classname::methodname>, \
+		{ ScriptInterface::callMethod<rettype, arg1, arg2, arg3, &class_##classname, classname, &classname::methodname>, NULL }, \
 		3, \
 		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_4(scriptname, rettype, classname, methodname, arg1, arg2, arg3, arg4) \
 	{ scriptname, \
-		ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, &class_##classname, classname, &classname::methodname>, \
+		{ ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, &class_##classname, classname, &classname::methodname>, NULL }, \
 		4, \
 		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_5(scriptname, rettype, classname, methodname, arg1, arg2, arg3, arg4, arg5) \
 	{ scriptname, \
-		ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, arg5, &class_##classname, classname, &classname::methodname>, \
+		{ ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, arg5, &class_##classname, classname, &classname::methodname>, NULL }, \
 		5, \
 		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_6(scriptname, rettype, classname, methodname, arg1, arg2, arg3, arg4, arg5, arg6) \
 	{ scriptname, \
-		ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, arg5, arg6, &class_##classname, classname, &classname::methodname>, \
+		{ ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, arg5, arg6, &class_##classname, classname, &classname::methodname>, NULL }, \
 		6, \
 		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
 #define DEFINE_INTERFACE_METHOD_7(scriptname, rettype, classname, methodname, arg1, arg2, arg3, arg4, arg5, arg6, arg7) \
 	{ scriptname, \
-		ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, arg5, arg6, arg7, &class_##classname, classname, &classname::methodname>, \
+		{ ScriptInterface::callMethod<rettype, arg1, arg2, arg3, arg4, arg5, arg6, arg7, &class_##classname, classname, &classname::methodname>, NULL }, \
 		7, \
 		JSPROP_ENUMERATE|JSPROP_READONLY|JSPROP_PERMANENT },
 
Index: source/simulation2/system/ParamNode.cpp
===================================================================
--- source/simulation2/system/ParamNode.cpp	(Revision 14578)
+++ source/simulation2/system/ParamNode.cpp	(Arbeitskopie)
@@ -25,8 +25,6 @@
 #include "ps/Filesystem.h"
 #include "ps/XML/Xeromyces.h"
 
-#include "js/jsapi.h"
-
 #include <sstream>
 
 // Disable "'boost::algorithm::detail::is_classifiedF' : assignment operator could not be generated"
@@ -328,6 +326,7 @@
 
 jsval CParamNode::ConstructJSVal(JSContext* cx) const
 {
+	JSAutoRequest rq(cx);
 	if (m_Childs.empty())
 	{
 		// Empty node - map to undefined
@@ -351,8 +350,8 @@
 
 	for (std::map<std::string, CParamNode>::const_iterator it = m_Childs.begin(); it != m_Childs.end(); ++it)
 	{
-		jsval childVal = it->second.ConstructJSVal(cx);
-		if (!JS_SetProperty(cx, obj, it->first.c_str(), &childVal))
+		JS::RootedValue childVal(cx, it->second.ConstructJSVal(cx));
+		if (!JS_SetProperty(cx, obj, it->first.c_str(), childVal.address()))
 			return JSVAL_VOID; // TODO: report error
 	}
 
@@ -363,8 +362,8 @@
 		JSString* str = JS_InternUCStringN(cx, reinterpret_cast<const jschar*>(text.data()), text.length());
 		if (!str)
 			return JSVAL_VOID; // TODO: report error
-		jsval childVal = STRING_TO_JSVAL(str);
-		if (!JS_SetProperty(cx, obj, "_string", &childVal))
+		JS::RootedValue childVal(cx, STRING_TO_JSVAL(str));
+		if (!JS_SetProperty(cx, obj, "_string", childVal.address()))
 			return JSVAL_VOID; // TODO: report error
 	}
 
